#ifndef __msp430_headers_opamp_h
#define __msp430_headers_opamp_h

/* opamp.h
 *
 * mspgcc project: MSP430 device headers
 * Operational amplifier module header
 *
 * (c) 2003 by Steve Underwood <steveu@coppice.org>
 * Originally based in part on work by Texas Instruments Inc.
 *
 * $Id: opamp.h,v 1.1 2003/11/20 12:52:16 coppice Exp $
 */

/* Switches: none */
#define SIFDEBUG_           (0x01B0)  /* SIF, Debug Register */
sfrw(SIFDEBUG, SIFDEBUG_);

#define OA0CTL0_            (0x00C0)  /* OA0 Control register 0 */
sfrb(OA0CTL0, OA0CTL0_);
#define OA0CTL1_            (0x00C1)  /* OA0 Control register 1 */
sfrb(OA0CTL1, OA0CTL1_);
#define OA1CTL0_            (0x00C0)  /* OA1 Control register 0 */
sfrb(OA1CTL0, OA1CTL0_);
#define OA1CTL1_            (0x00C1)  /* OA1 Control register 1 */
sfrb(OA1CTL1, OA1CTL1_);
#define OA2CTL0_            (0x00C0)  /* OA2 Control register 0 */
sfrb(OA2CTL0, OA2CTL0_);
#define OA2CTL1_            (0x00C1)  /* OA2 Control register 1 */
sfrb(OA2CTL1, OA2CTL1_);

#define OA0ADC0             (0x01)    /* OA0 output to ADC12 input channel select 0 */
#define OA0ADC1             (0x02)    /* OA0 output to ADC12 input channel select 1 */
#define OA0PM0              (0x04)    /* OA0 Power mode select 0 */
#define OA0PM1              (0x08)    /* OA0 Power mode select 1 */
#define OA0P0               (0x10)    /* OA0 Inverting input select 0 */
#define OA0P1               (0x20)    /* OA0 Inverting input select 1 */
#define OA0N0               (0x40)    /* OA0 Non-inverting input select 0 */
#define OA0N1               (0x80)    /* OA0 Non-inverting input select 1 */

#define OA0PM_0             (0x00)    /* OA0 Power mode select: off */
#define OA0PM_1             (0x04)    /* OA0 Power mode select: slow */
#define OA0PM_2             (0x08)    /* OA0 Power mode select: meduim */
#define OA0PM_3             (0x0C)    /* OA0 Power mode select: fast */
#define OA0P_0              (0x00)    /* OA0 Inverting input select 00 */
#define OA0P_1              (0x10)    /* OA0 Inverting input select 01 */
#define OA0P_2              (0x20)    /* OA0 Inverting input select 10 */
#define OA0P_3              (0x30)    /* OA0 Inverting input select 11 */
#define OA0N_0              (0x40)    /* OA0 Non-inverting input select 00 */
#define OA0N_1              (0x40)    /* OA0 Non-inverting input select 01 */
#define OA0N_2              (0x80)    /* OA0 Non-inverting input select 10 */
#define OA0N_3              (0x40)    /* OA0 Non-inverting input select 11 */

#define OA0RRIP             (0x01)    /* OA0 Rail-to-Rail Input off */
//#define Reserved          (0x02)    /* */
#define OA0FC0              (0x04)    /* OA0 Function control 0 */
#define OA0FC1              (0x08)    /* OA0 Function control 1 */
#define OA0FC2              (0x10)    /* OA0 Function control 2 */
#define OA0FBR0             (0x20)    /* OA0 Feedback resistor select 0 */
#define OA0FBR1             (0x40)    /* OA0 Feedback resistor select 1 */
#define OA0FBR2             (0x80)    /* OA0 Feedback resistor select 2 */

#define OA0FC_0             (0x00)    /* OA0 Function: Gen. Purpose */
#define OA0FC_1             (0x04)    /* OA0 Function: Comparing */
#define OA0FC_2             (0x08)    /* OA0 Function: Reserved */
#define OA0FC_3             (0x0C)    /* OA0 Function: Differential */
#define OA0FC_4             (0x10)    /* OA0 Function: Non-Inverting, PGA */
#define OA0FC_5             (0x14)    /* OA0 Function: Reserved */
#define OA0FC_6             (0x18)    /* OA0 Function: Inverting */
#define OA0FC_7             (0x1C)    /* OA0 Function: Differential */
#define OA0FBR_0            (0x00)    /* OA0 Feedback resistor: Tap 0 */
#define OA0FBR_1            (0x20)    /* OA0 Feedback resistor: Tap 1 */
#define OA0FBR_2            (0x40)    /* OA0 Feedback resistor: Tap 2 */
#define OA0FBR_3            (0x60)    /* OA0 Feedback resistor: Tap 3 */
#define OA0FBR_4            (0x80)    /* OA0 Feedback resistor: Tap 4 */
#define OA0FBR_5            (0xA0)    /* OA0 Feedback resistor: Tap 5 */
#define OA0FBR_6            (0xC0)    /* OA0 Feedback resistor: Tap 6 */
#define OA0FBR_7            (0xE0)    /* OA0 Feedback resistor: Tap 7 */

#define OA1ADC0             (0x01)    /* OA1 output to ADC12 input channel select 0 */
#define OA1ADC1             (0x02)    /* OA1 output to ADC12 input channel select 1 */
#define OA1PM0              (0x04)    /* OA1 Power mode select 0 */
#define OA1PM1              (0x08)    /* OA1 Power mode select 1 */
#define OA1P0               (0x10)    /* OA1 Inverting input select 0 */
#define OA1P1               (0x20)    /* OA1 Inverting input select 1 */
#define OA1N0               (0x40)    /* OA1 Non-inverting input select 0 */
#define OA1N1               (0x80)    /* OA1 Non-inverting input select 1 */

#define OA1PM_0             (0x00)    /* OA1 Power mode select: off */
#define OA1PM_1             (0x04)    /* OA1 Power mode select: slow */
#define OA1PM_2             (0x08)    /* OA1 Power mode select: meduim */
#define OA1PM_3             (0x0C)    /* OA1 Power mode select: fast */
#define OA1P_0              (0x00)    /* OA1 Inverting input select 00 */
#define OA1P_1              (0x10)    /* OA1 Inverting input select 01 */
#define OA1P_2              (0x20)    /* OA1 Inverting input select 10 */
#define OA1P_3              (0x30)    /* OA1 Inverting input select 11 */
#define OA1N_0              (0x40)    /* OA1 Non-inverting input select 00 */
#define OA1N_1              (0x40)    /* OA1 Non-inverting input select 01 */
#define OA1N_2              (0x80)    /* OA1 Non-inverting input select 10 */
#define OA1N_3              (0x40)    /* OA1 Non-inverting input select 11 */

#define OA1RRIP             (0x01)    /* OA1 Rail-to-Rail Input off */
//#define Reserved          (0x02)    /* */
#define OA1FC0              (0x04)    /* OA1 Function control 0 */
#define OA1FC1              (0x08)    /* OA1 Function control 1 */
#define OA1FC2              (0x10)    /* OA1 Function control 2 */
#define OA1FBR0             (0x20)    /* OA1 Feedback resistor select 0 */
#define OA1FBR1             (0x40)    /* OA1 Feedback resistor select 1 */
#define OA1FBR2             (0x80)    /* OA1 Feedback resistor select 2 */

#define OA1FC_0             (0x00)    /* OA1 Function: Gen. Purpose */
#define OA1FC_1             (0x04)    /* OA1 Function: Comparing */
#define OA1FC_2             (0x08)    /* OA1 Function: Reserved */
#define OA1FC_3             (0x0C)    /* OA1 Function: Differential */
#define OA1FC_4             (0x10)    /* OA1 Function: Non-Inverting, PGA */
#define OA1FC_5             (0x14)    /* OA1 Function: Reserved */
#define OA1FC_6             (0x18)    /* OA1 Function: Inverting */
#define OA1FC_7             (0x1C)    /* OA1 Function: Differential */
#define OA1FBR_0            (0x00)    /* OA1 Feedback resistor: Tap 0 */
#define OA1FBR_1            (0x20)    /* OA1 Feedback resistor: Tap 1 */
#define OA1FBR_2            (0x40)    /* OA1 Feedback resistor: Tap 2 */
#define OA1FBR_3            (0x60)    /* OA1 Feedback resistor: Tap 3 */
#define OA1FBR_4            (0x80)    /* OA1 Feedback resistor: Tap 4 */
#define OA1FBR_5            (0xA0)    /* OA1 Feedback resistor: Tap 5 */
#define OA1FBR_6            (0xC0)    /* OA1 Feedback resistor: Tap 6 */
#define OA1FBR_7            (0xE0)    /* OA1 Feedback resistor: Tap 7 */

#define OA2ADC0             (0x01)    /* OA2 output to ADC12 input channel select 0 */
#define OA2ADC1             (0x02)    /* OA2 output to ADC12 input channel select 1 */
#define OA2PM0              (0x04)    /* OA2 Power mode select 0 */
#define OA2PM1              (0x08)    /* OA2 Power mode select 1 */
#define OP2P0               (0x00)    /* OA2 Inverting input select 0 */
#define OA2P1               (0x20)    /* OA2 Inverting input select 1 */
#define OA2N0               (0x40)    /* OA2 Non-inverting input select 0 */
#define OA2N1               (0xC0)    /* OA2 Non-inverting input select 1 */

#define OA2PM_0             (0x00)    /* OA2 Power mode select: off */
#define OA2PM_1             (0x04)    /* OA2 Power mode select: slow */
#define OA2PM_2             (0x08)    /* OA2 Power mode select: meduim */
#define OA2PM_3             (0x0C)    /* OA2 Power mode select: fast */
#define OA2P_0              (0x00)    /* OA2 Inverting input select 00 */
#define OA2P_1              (0x10)    /* OA2 Inverting input select 01 */
#define OA2P_2              (0x20)    /* OA2 Inverting input select 10 */
#define OA2P_3              (0x30)    /* OA2 Inverting input select 11 */
#define OA2N_0              (0x40)    /* OA2 Non-inverting input select 00 */
#define OA2N_1              (0x40)    /* OA2 Non-inverting input select 01 */
#define OA2N_2              (0x80)    /* OA2 Non-inverting input select 10 */
#define OA2N_3              (0x40)    /* OA2 Non-inverting input select 11 */

#define OA2RRIP             (0x01)    /* OA2 Rail-to-Rail Input off */
//#define Reserved          (0x02)    /* */
#define OA2FC0              (0x04)    /* OA2 Function control 0 */
#define OA2FC1              (0x08)    /* OA2 Function control 1 */
#define OA2FC2              (0x10)    /* OA2 Function control 2 */
#define OA2FBR0             (0x20)    /* OA2 Feedback resistor select 0 */
#define OA2FBR1             (0x40)    /* OA2 Feedback resistor select 1 */
#define OA2FBR2             (0x80)    /* OA2 Feedback resistor select 2 */

#define OA2FC_0             (0x00)    /* OA2 Function: Gen. Purpose */
#define OA2FC_1             (0x04)    /* OA2 Function: Comparing */
#define OA2FC_2             (0x08)    /* OA2 Function: Reserved */
#define OA2FC_3             (0x0C)    /* OA2 Function: Differential */
#define OA2FC_4             (0x10)    /* OA2 Function: Non-Inverting, PGA */
#define OA2FC_5             (0x14)    /* OA2 Function: Reserved */
#define OA2FC_6             (0x18)    /* OA2 Function: Inverting */
#define OA2FC_7             (0x1C)    /* OA2 Function: Differential */
#define OA2FBR_0            (0x00)    /* OA2 Feedback resistor: Tap 0 */
#define OA2FBR_1            (0x20)    /* OA2 Feedback resistor: Tap 1 */
#define OA2FBR_2            (0x40)    /* OA2 Feedback resistor: Tap 2 */
#define OA2FBR_3            (0x60)    /* OA2 Feedback resistor: Tap 3 */
#define OA2FBR_4            (0x80)    /* OA2 Feedback resistor: Tap 4 */
#define OA2FBR_5            (0xA0)    /* OA2 Feedback resistor: Tap 5 */
#define OA2FBR_6            (0xC0)    /* OA2 Feedback resistor: Tap 6 */
#define OA2FBR_7            (0xE0)    /* OA2 Feedback resistor: Tap 7 */

#endif
