#include <io.h>
;******************************************************************************
;   MSP-FET430P410 Demo - BasicTimer Toggle P5.1 using ISR, DCO SMCLK 
;
;   Description; This program will toggle P5.1 by xor'ing P5.1 inside of
;   a basic timer ISR. Default DCO used to clock basic timer. 
;   ACLK = n/a, MCLK = SMCLK = default DCO
;
;                MSP430F413
;             -----------------
;         /|\|              XIN|-  
;          | |                 |
;          --|RST          XOUT|-
;            |                 |
;            |             P5.1|-->LED
;
;   M.Buccini
;   Texas Instruments, Inc
;   January 2002
;   Adapted for mspgcc by Steve Underwood <steveu@coppice.org>
;******************************************************************************
            .section    .text
RESET:      mov.w   #0x300,R1               ; Initialize stackpointer
Init_Sys:   mov.w   #WDTPW+WDTHOLD,&WDTCTL  ; Stop WDT
SetupBT:    mov.b   #BTSSEL+BTIP2+BTIP1+BTIP0,&BTCTL   ; ~244us Int. 
            bis.b   #BTIE,&IE2              ; Enable Basic Timer interrupt        
SetupP1:    bis.b   #0x02,&P5DIR            ; P5.1 output
            eint                            ; Enable interrupts
                                            ;						  
Mainloop:   bis.w   #CPUOFF,R2              ; CPU off
            nop                             ; Required for C-spy
                                            ;
;------------------------------------------------------------------------------
BT_ISR:     ;Toggle P5.1
;------------------------------------------------------------------------------
            xor.b   #0x02,&P5OUT            ; Toggle P5.1
            reti                            ;		 
                                            ;   
;----------------------------------------------------------------------------- 
;           Interrupt Vectors Used MSP430F41x         
;----------------------------------------------------------------------------- 
            .section    .vectors
            .org    0x00,0xFF               ; BT Vector
            .word   BT_ISR                  ; 
            .org    0x1E,0xFF               ; MSP430 RESET Vector
            .word   RESET                   ; 
