#include <io.h>
;******************************************************************************
;   MSP-FET430P410 Demo - FLL+ Output MCLK, ACLK Using 32k XTAL and DCO 
;
;   Description; This program will output the system MCLK and ACLK.
;   ACLK = LFXT1 = 32768, MCLK = DCO = 32xACLK  1.048576MHz
;   //*An external watch crystal is required on XIN/XOUT for ACLK*//	  
;
;                 MSP430F413
;             -----------------
;         /|\|              XIN|-  
;          | |                 | 32kHz
;          --|RST          XOUT|-
;            |                 |
;            |             P1.1|-->MCLK 1048576
;            |             P1.5|-->ACLK 32kHz
;
;   M.Buccini
;   Texas Instruments, Inc
;   January 2002
;   Adapted for mspgcc by Steve Underwood <steveu@coppice.org>
;******************************************************************************
            .section    .text
RESET:      mov.w   #0x300,R1               ; Initialize stackpointer
StopWDT:    mov.w   #WDTPW+WDTHOLD,&WDTCTL  ; Stop WDT
SetupFLL:   bis.b   #XCAP14PF,&FLL_CTL0     ; Configure load caps
SetupP1:    bis.b   #0x22,&P1DIR            ; P1.1 and P1.5 output direction
            bis.b   #0x22,&P1SEL            ; P1.1 and P1.5 option select
                                            ;				          							  
Mainloop:   jmp     Mainloop                ; 
                                            ;
;----------------------------------------------------------------------------- 
;           Interrupt Vectors Used MSP430F41x         
;----------------------------------------------------------------------------- 
            .section    .vectors
            .org    0x1E,0xFF               ; MSP430 RESET Vector
            .word   RESET                   ; 
